<?php
/**
 * PAYGENT B2B MODULE
 * ResponseDataFactory.php
 * 
 * Copyright (C) 2007 by PAYGENT Co., Ltd.
 * All rights reserved.
 */

include_once("jp/co/ks/merchanttool/connectmodule/exception/PaygentB2BModuleException.php");
include_once("jp/co/ks/merchanttool/connectmodule/system/PaygentB2BModuleResources.php");
include_once("jp/co/ks/merchanttool/connectmodule/entity/ReferenceResponseDataImpl.php");
include_once("jp/co/ks/merchanttool/connectmodule/entity/PaymentResponseDataImpl.php");

/**
 * dpIuWFNg쐬NX
 * 
 * @version $Revision: 1.4 $
 * @author $Author: t-mori $
 */
class ResponseDataFactory {

	/**
	 * ResponseData 쐬
	 * 
	 * @param kind
	 * @return ResponseData
	 */
	function create($kind) {
		$resData = null;
		$masterFile = null;
		
		$masterFile = PaygentB2BModuleResources::getInstance();
		
		// Create ResponseData
		if ($masterFile->isTelegramKindRef($kind)) {
			// Ɖ̏ꍇ
			$resData = new ReferenceResponseDataImpl();
		} else {
			// ƉȊȌꍇ
			$resData = new PaymentResponseDataImpl();
		}

		return $resData;
	}

}

?>