<?php
/**
 * PAYGENT B2B MODULE
 * PaygentB2BModuleResources.php
 * 
 * Copyright (C) 2007 by PAYGENT Co., Ltd.
 * All rights reserved.
 */

/*
 * vpeBt@CǍAlێNX
 * 
 * @version $Revision: 1.6 $
 * @author $Author: t-mori $
 */

include_once("jp/co/ks/merchanttool/connectmodule/util/StringUtil.php");
include_once("jp/co/ks/merchanttool/connectmodule/exception/PaygentB2BModuleConnectException.php");
include_once("jp/co/ks/merchanttool/connectmodule/exception/PaygentB2BModuleException.php");

	/**
	 * vpeBt@C
	 */
	define("PaygentB2BModuleResources__PROPERTIES_FILE_NAME", "modenv.properties");

	/**
	 * Ɖndʂ̋؂蕶
	 */
	define("PaygentB2BModuleResources__TELEGRAM_KIND_SEPARATOR", ",");
	
	/**
	 * dʂ̐擪iڑURL擾j
	 */
	define("PaygentB2BModuleResources__TELEGRAM_KIND_FIRST_CHARS", 2);

	/**
	 * NCAgؖt@CpX
	 */
	define("PaygentB2BModuleResources__CLIENT_FILE_PATH", "paygentB2Bmodule.client_file_path");

	/**
	 * CAؖt@CpX
	 */
	define("PaygentB2BModuleResources__CA_FILE_PATH", "paygentB2Bmodule.ca_file_path");

	/**
	 * ProxyT[o
	 */
	define("PaygentB2BModuleResources__PROXY_SERVER_NAME", "paygentB2Bmodule.proxy_server_name");

	/**
	 * ProxyIPAhX
	 */
	define("PaygentB2BModuleResources__PROXY_SERVER_IP", "paygentB2Bmodule.proxy_server_ip");

	/**
	 * Proxy|[gԍ
	 */
	define("PaygentB2BModuleResources__PROXY_SERVER_PORT", "paygentB2Bmodule.proxy_server_port");

	/**
	 * ftHgID
	 */
	define("PaygentB2BModuleResources__DEFAULT_ID", "paygentB2Bmodule.default_id");

	/**
	 * ftHgpX[h
	 */
	define("PaygentB2BModuleResources__DEFAULT_PASSWORD", "paygentB2Bmodule.default_password");

	/**
	 * ^CAEgl
	 */
	define("PaygentB2BModuleResources__TIMEOUT_VALUE", "paygentB2Bmodule.timeout_value");

	/**
	 * Oo͐
	 */
	define("PaygentB2BModuleResources__LOG_OUTPUT_PATH", "paygentB2Bmodule.log_output_path");

	/**
	 * ƉMAX
	 */
	define("PaygentB2BModuleResources__SELECT_MAX_CNT", "paygentB2Bmodule.select_max_cnt");

	/**
	 * ƉndID
	 */
	define("PaygentB2BModuleResources__TELEGRAM_KIND_REFS", "paygentB2Bmodule.telegram_kind.ref");

	/**
	 * ڑURLiʁj
	 */
	define("PaygentB2BModuleResources__URL_COMM", "paygentB2Bmodule.url.");


 class PaygentB2BModuleResources {
 	
	/** NCAgؖt@CpX */
	var $clientFilePath = "";

	/** CAؖt@CpX */
	var $caFilePath = "";

	/** ProxyT[o */
	var $proxyServerName = "";

	/** ProxyIPAhX */
	var $proxyServerIp = "";

	/** Proxy|[gԍ */
	var $proxyServerPort = 0;

	/** ftHgID */
	var $defaultId = "";

	/** ftHgpX[h */
	var $defaultPassword = "";

	/** ^CAEgl */
	var $timeout = 0;

	/** Oo͐ */
	var $logOutputPath = "";

	/** ƉMAX */
	var $selectMaxCnt = 0;
	
	/** ݒt@CivpeBj */
	var $propConnect = null;

	/** ƉndʃXg */
	var $telegramKindRefs = null;

	/**
	 * RXgN^
	 */
	function PaygentB2BModuleResources() {
	}

	/**
	 * PaygentB2BModuleResources 擾
	 * 
	 * @return PaygentB2BModuleResources@s̏ꍇAG[R[h
	 */
	function &getInstance() {
		static $resourceInstance = null;
		
		if (isset($resourceInstance) == false 
			|| $resourceInstance == null
			|| is_object($resourceInstance) != true) {
			
			$resourceInstance = new PaygentB2BModuleResources();
			$rslt = $resourceInstance->readProperties();
			if ($rslt === true) {
			} else {
				$resourceInstance = $rslt;
			} 
		}

		return $resourceInstance;
	}

	/**
	 * NCAgؖt@CpX擾B
	 * 
	 * @return clientFilePath
	 */
	function getClientFilePath() {
		return $this->clientFilePath;
	}

	/**
	 * CAؖt@CpX擾B
	 * 
	 * @return caFilePath
	 */
	function getCaFilePath() {
		return $this->caFilePath;
	}

	/**
	 * ProxyT[o擾B
	 * 
	 * @return proxyServerName
	 */
	function getProxyServerName() {
		return $this->proxyServerName;
	}

	/**
	 * ProxyIPAhX擾B
	 * 
	 * @return proxyServerIp
	 */
	function getProxyServerIp() {
		return $this->proxyServerIp;
	}

	/**
	 * Proxy|[gԍ擾B
	 * 
	 * @return proxyServerPort
	 */
	function getProxyServerPort() {
		return $this->proxyServerPort;
	}

	/**
	 * ftHgID擾B
	 * 
	 * @return defaultId
	 */
	function getDefaultId() {
		return $this->defaultId;
	}

	/**
	 * ftHgpX[h擾B
	 * 
	 * @return defaultPassword
	 */
	function getDefaultPassword() {
		return $this->defaultPassword;
	}

	/**
	 * ^CAEgl擾B
	 * 
	 * @return timeout
	 */
	function getTimeout() {
		return $this->timeout;
	}

	/**
	 * Oo͐擾B
	 * 
	 * @return logOutputPath
	 */
	function getLogOutputPath() {
		return $this->logOutputPath;
	}

	/**
	 * ƉMAX擾B
	 * 
	 * @return selectMaxCnt
	 */
	function getSelectMaxCnt() {
		return $this->selectMaxCnt;
	}

	/**
	 * ڑURL擾B
	 * 
	 * @param telegramKind
	 * @return FALSE: s(PaygentB2BModuleConnectException::TEREGRAM_PARAM_OUTSIDE_ERROR)A:擾 URL
	 */
	function getUrl($telegramKind) {
		$rs = null;
		$sKey = null;

		// vpeB`FbN
		if ($this->propConnect == null) {
			trigger_error(PaygentB2BModuleConnectException__TEREGRAM_PARAM_OUTSIDE_ERROR 
				. ": HTTP request contains unexpected value.", E_USER_WARNING);
			return false;
		}
		
		// `FbN
		if (StringUtil::isEmpty($telegramKind)) {
			trigger_error(PaygentB2BModuleConnectException__TEREGRAM_PARAM_OUTSIDE_ERROR 
				. ": HTTP request contains unexpected value.", E_USER_WARNING);
			return false;
		}

		// SŃvpeBURL擾
		$sKey = PaygentB2BModuleResources__URL_COMM . $telegramKind;
		if (array_key_exists($sKey, $this->propConnect)) {
			$rs = $this->propConnect[$sKey];
		}
		
		// SŎ擾łꍇA̒l߂
		if (!StringUtil::isEmpty($rs)) {
			return $rs;
		}
		
		// 擪QŃvpeBURL擾
		if (strlen($telegramKind) > PaygentB2BModuleResources__TELEGRAM_KIND_FIRST_CHARS) {
			$sKey = PaygentB2BModuleResources__URL_COMM 
				. substr($telegramKind, 0, PaygentB2BModuleResources__TELEGRAM_KIND_FIRST_CHARS);
		} else {
			// SƂȂAG[Ƃ
			trigger_error(PaygentB2BModuleConnectException__TEREGRAM_PARAM_OUTSIDE_ERROR 
				. ": HTTP request contains unexpected value.", E_USER_WARNING);
			return false;
		}
		if (array_key_exists($sKey, $this->propConnect)) {
			$rs = $this->propConnect[$sKey];
		}
		
		// SƐ擪QŎ擾łȂꍇAG[߂
		if (StringUtil::isEmpty($rs)) {
			trigger_error(PaygentB2BModuleConnectException__TEREGRAM_PARAM_OUTSIDE_ERROR 
				. ": HTTP request contains unexpected value.", E_USER_WARNING);
			return false;
		}
		
		return $rs;
	}

	/**
	 * PropertiesFile ̒l擾AݒB
	 *
	 * @return mixed FTRUEAFG[R[h 
	 */
	function readProperties() {

		// Properties File Read
		$prop = null;

		$prop = PaygentB2BModuleResources::parseJavaProperty(PaygentB2BModuleResources__PROPERTIES_FILE_NAME);
		if ($prop === false) {
			// Properties File ǍG[
			trigger_error(PaygentB2BModuleException__RESOURCE_FILE_NOT_FOUND_ERROR
				. ": Properties file doesn't exist.", E_USER_WARNING);
			return PaygentB2BModuleException__RESOURCE_FILE_NOT_FOUND_ERROR; 
		}

		// K{ڃG[`FbN
		if (!($this->isPropertiesIndispensableItem($prop) 
			&& $this->isPropertiesSetData($prop) 
			&& $this->isPropertieSetInt($prop))
			|| $this->isURLNull($prop)) {
			// K{ڃG[
			$propConnect = null;
			trigger_error(PaygentB2BModuleException__RESOURCE_FILE_REQUIRED_ERROR
				. ": Properties file contains inappropriate value.", E_USER_WARNING);
			return PaygentB2BModuleException__RESOURCE_FILE_REQUIRED_ERROR; 
		}
		$this->propConnect = $prop;
		
		// NCAgؖt@CpX
		if (array_key_exists(PaygentB2BModuleResources__CLIENT_FILE_PATH, $prop)
				&& !(StringUtil::isEmpty($prop[PaygentB2BModuleResources__CLIENT_FILE_PATH]))) {
			$this->clientFilePath = $prop[PaygentB2BModuleResources__CLIENT_FILE_PATH];
		}

		// CAؖt@CpX
		if (array_key_exists(PaygentB2BModuleResources__CA_FILE_PATH, $prop)
				&& !(StringUtil::isEmpty($prop[PaygentB2BModuleResources__CA_FILE_PATH]))) {
			$this->caFilePath = $prop[PaygentB2BModuleResources__CA_FILE_PATH];
		}

		// ProxyT[o
		if (array_key_exists(PaygentB2BModuleResources__PROXY_SERVER_NAME, $prop)
				&& !(StringUtil::isEmpty($prop[PaygentB2BModuleResources__PROXY_SERVER_NAME]))) {
			$this->proxyServerName = $prop[PaygentB2BModuleResources__PROXY_SERVER_NAME];
		}

		// ProxyIPAhX
		if (array_key_exists(PaygentB2BModuleResources__PROXY_SERVER_IP, $prop)
				&& !(StringUtil::isEmpty($prop[PaygentB2BModuleResources__PROXY_SERVER_IP]))) {
			$this->proxyServerIp = $prop[PaygentB2BModuleResources__PROXY_SERVER_IP];
		}

		// Proxy|[gԍ
		if (array_key_exists(PaygentB2BModuleResources__PROXY_SERVER_PORT, $prop)
				&& !(StringUtil::isEmpty($prop[PaygentB2BModuleResources__PROXY_SERVER_PORT]))) {
			if (StringUtil::isNumeric($prop[PaygentB2BModuleResources__PROXY_SERVER_PORT])) {
				$this->proxyServerPort = $prop[PaygentB2BModuleResources__PROXY_SERVER_PORT];
			} else {
				// ݒlG[
				trigger_error(PaygentB2BModuleException__RESOURCE_FILE_REQUIRED_ERROR
					. ": Properties file contains inappropriate value.", E_USER_WARNING);
				return PaygentB2BModuleException__RESOURCE_FILE_REQUIRED_ERROR; 
			}
		}

		// ftHgID
		if (array_key_exists(PaygentB2BModuleResources__DEFAULT_ID, $prop)
				&& !(StringUtil::isEmpty($prop[PaygentB2BModuleResources__DEFAULT_ID]))) {
			$this->defaultId = $prop[PaygentB2BModuleResources__DEFAULT_ID];
		}

		// ftHgpX[h
		if (array_key_exists(PaygentB2BModuleResources__DEFAULT_PASSWORD, $prop)
				&& !(StringUtil::isEmpty($prop[PaygentB2BModuleResources__DEFAULT_PASSWORD]))) {
			$this->defaultPassword = $prop[PaygentB2BModuleResources__DEFAULT_PASSWORD];
		}

		// ^CAEgl
		if (array_key_exists(PaygentB2BModuleResources__TIMEOUT_VALUE, $prop)
				&& !(StringUtil::isEmpty($prop[PaygentB2BModuleResources__TIMEOUT_VALUE]))) {
			$this->timeout = $prop[PaygentB2BModuleResources__TIMEOUT_VALUE];
		}

		// Oo͐
		if (array_key_exists(PaygentB2BModuleResources__LOG_OUTPUT_PATH, $prop)
				&& !(StringUtil::isEmpty($prop[PaygentB2BModuleResources__LOG_OUTPUT_PATH]))) {
			$this->logOutputPath = $prop[PaygentB2BModuleResources__LOG_OUTPUT_PATH];
		}

		// ƉMAX
		if (array_key_exists(PaygentB2BModuleResources__SELECT_MAX_CNT, $prop)
				&& !(StringUtil::isEmpty($prop[PaygentB2BModuleResources__SELECT_MAX_CNT]))) {
			$this->selectMaxCnt = $prop[PaygentB2BModuleResources__SELECT_MAX_CNT];
		}

		// ƉdʃXg
		if (array_key_exists(PaygentB2BModuleResources__TELEGRAM_KIND_REFS, $prop)
				&& !(StringUtil::isEmpty($prop[PaygentB2BModuleResources__TELEGRAM_KIND_REFS]))) {
			$telegramKindRef = $prop[PaygentB2BModuleResources__TELEGRAM_KIND_REFS];
			$this->telegramKindRefs = $this->split($telegramKindRef, PaygentB2BModuleResources__TELEGRAM_KIND_SEPARATOR);
		}
		if ($this->telegramKindRefs == null) {
			$this->telegramKindRefs = array();
		}
		
		return true;
	}

	/**
	 * Properties K{ڃ`FbN
	 * 
	 * @param Properties
	 * @return boolean true=K{ڗL false=K{ږ
	 */
	function isPropertiesIndispensableItem($prop) {
		$rb = false;

		if ((array_key_exists(PaygentB2BModuleResources__CLIENT_FILE_PATH, $prop)
				&& array_key_exists(PaygentB2BModuleResources__CA_FILE_PATH, $prop)
				&& array_key_exists(PaygentB2BModuleResources__TIMEOUT_VALUE, $prop)
				&& array_key_exists(PaygentB2BModuleResources__LOG_OUTPUT_PATH, $prop)
				&& array_key_exists(PaygentB2BModuleResources__SELECT_MAX_CNT, $prop))) {
			// K{ڗL
			$rb = true;
		}

		return $rb;
	}

	/**
	 * Properties f[^ݒ`FbN
	 * 
	 * @param prop Properties
	 * @return boolean true=f[^ݒ荀ږ false=f[^ݒ荀ڗL
	 */
	function isPropertiesSetData($prop) {
		$rb = true;

		if (StringUtil::isEmpty($prop[PaygentB2BModuleResources__CLIENT_FILE_PATH])
				|| StringUtil::isEmpty($prop[PaygentB2BModuleResources__CA_FILE_PATH])
				|| StringUtil::isEmpty($prop[PaygentB2BModuleResources__TIMEOUT_VALUE])
				|| StringUtil::isEmpty($prop[PaygentB2BModuleResources__SELECT_MAX_CNT])) {
			// K{ږݒG[
			$rb = false;
		}

		return $rb;
	}

	/**
	 * Properties l`FbN
	 * 
	 * @param prop Properties
	 * @return boolean true=lݒ false=lݒ
	 */
	function isPropertieSetInt($prop) {
		$rb = false;

		if (StringUtil::isNumeric($prop[PaygentB2BModuleResources__TIMEOUT_VALUE])
				&& StringUtil::isNumeric($prop[PaygentB2BModuleResources__SELECT_MAX_CNT])) {
			// lݒ
			$rb = true;
		}

		return $rb;
	}
	
	/**
	 * ڑURL̓kǂ̃`FbN
	 * 
	 */
	function isURLNull($prop) {
		$rb = false;
		if (!is_array($prop)) {
			return true;
		}
		
		foreach($prop as $key => $value) {
			
			if (strpos($key, PaygentB2BModuleResources__URL_COMM) === 0) {
				if (isset($value) == false 
					|| strlen(trim($value)) == 0) {
					$rb = true;
					break;
				}
			}
		}
		return $rb;
	}
	
	/**
	 * w肳ꂽ؂蕶ŕ𕪊Ag
	 * 
	 * @param str 
	 * @param separator ؂蕶
	 * @return Xg
	 */
	function split($str, $separator) {
		$list = array();
		
		if ($str == null) {
			return $list;
		}
		
		if ($separator == null || strlen($separator) == 0) {
			if (!StringUtil::isEmpty(trim($str))) {
				$list[] = trim($str);
			}
			return $list;
		}
		
		$arr = explode($separator, $str);
		for ($i=0; $arr && $i < sizeof($arr); $i++) {
			if (!StringUtil::isEmpty(trim($arr[$i]))) {
				$list[] = trim($arr[$i]);
			}
		}
		
		return $list;
	}
	
	/**
	 * Ɖd`FbN
	 * @param telegramKind d
	 * @return true=Ɖd false=ƉdȊO
	 */
	function isTelegramKindRef($telegramKind) {
		$bRet = false;
		
		if ($this->telegramKindRefs == null) {
			return $bRet;
		}
		$bRet = in_array($telegramKind, $this->telegramKindRefs);
		return $bRet;
	}
 	
 	/**
 	 * JavatH[}bg̃vpeBt@Cl擾
 	 * zɓĕԂ
 	 * 
 	 * @param fileName vpeBt@C
 	 * @param commentChar Rgp
 	 * @return FALSE: sA:KEY=VALUE`̔z,
 	 */
 	function parseJavaProperty($fileName, $commentChar = "#") {

		$properties = array();
		
		$lines = @file($fileName, FILE_USE_INCLUDE_PATH | FILE_IGNORE_NEW_LINES);
 		if ($lines === false) {
			// Properties File ǍG[
			return $lines;
 		}
 		
 		foreach ($lines as $i => $line) {
 			$lineData = trim($line);
 			
 			$index = strpos($lineData, '\r');
 			if (!($index === false)) {
 				$lineData = trim(substr($lineData, 0, $index));
 			}
 			$index = strpos($lineData, '\n');
 			if (!($index === false)) {
 				$lineData = trim(substr($lineData, 0, $index));
 			}

 			if (strlen($lineData) <= 0) {
 				continue;
 			}
 			$firstChar = substr($lineData, 0, strlen($commentChar));
 			
 			if ($firstChar == $commentChar) {
 				continue;
 			}
 			
			$quotationIndex = strpos($lineData, '=');
			if ($quotationIndex <= 0) {
				continue;
			}
			
			$key = trim(substr($lineData, 0, $quotationIndex));
			$value = null;
			if (strlen($lineData) > $quotationIndex) {
				$value = trim(substr($lineData, $quotationIndex + 1));
			}
			$properties[$key] = $value;
 		}
 		
 		return $properties;
 	}
	
 }
?>
