<?php
/**
 * PAYGENT B2B MODULE
 * PaygentB2BModuleLogger.php
 * 
 * Copyright (C) 2007 by PAYGENT Co., Ltd.
 * All rights reserved.
 */

include_once("jp/co/ks/merchanttool/connectmodule/system/PaygentB2BModuleResources.php");

/**
 * ڑW[p Logger NX
 * 
 * @version $Revision: 1.6 $
 * @author $Author: t-mori $
 */

class PaygentB2BModuleLogger {

	/** FileAppender ێ */
	var $filename = null;

	/**
	 * RXgN^
	 */
	function PaygentB2BModuleLogger() {
		$inst = PaygentB2BModuleResources::getInstance();
		if (is_object($inst) && 
			!StringUtil::isEmpty($inst->getLogOutputPath())) {
			$this->filename = $inst->getLogOutputPath();
		}
	}
	
	/**
	 * PaygentB2BModuleLogger 擾
	 * 
	 * @return PaygentB2BModuleLogger
	 */
	function &getInstance() {
		static $logInstance = null;		
		if (isset($logInstance) == false
			|| $logInstance == null
			|| is_object($logInstance) != true) {

			$logInstance = new PaygentB2BModuleLogger();
		}
		return $logInstance;
	}

	/**
	 * fobOOo
	 * 
	 * @param className String Ȍo͌NX o͌
	 * @param message Object ObZ[W
	 */
	function debug($className, $message) {
		if(is_null($this->filename) == false && $this->filename != "") {
			if(! $handle = fopen( $this->filename, 'a')) {
				// t@CJȂ
				trigger_error(PaygentB2BModuleException__OTHER_ERROR. ":File doesn't open.(".$this->filename.").", E_USER_WARNING);
				return;
			}
			if(! fwrite($handle, $this->outputMsg($message, $className))) {
				// t@Cɏ߂Ȃ
				trigger_error(PaygentB2BModuleException__OTHER_ERROR. ":It is not possible to write it in the file(".$this->filename.").", E_USER_WARNING);
				return;
			}
			fclose($handle);
		}
	}
	
	/**
	 * o̓bZ[W𐮌`
	 * 
	 * @param message ObZ[W
	 * @param className NX
	 * @return `̃bZ[W
	 */
	function outputMsg($message, $className) {
		return date("Y/m/d H:i:s")." $className ".$message."\n";
	}
}

?>
